//
// d o s - c o n s o l e . c
//
// DOS console module
//
// Sep. 11, 2002 by W.Nishida (http://www.skyfree.org)
//

asm(".code16gcc");

// Character print

void printc(char ch) {
  asm("
	pushl	%edx			# Save current EDX
	movl	8( %ebp ), %edx		# Get character code
	movb	$2, %ah			# Output a character
	int	$0x21			# Do function call
	popl	%edx			# Restore EDX
  ");
 }

// String print

void prints(char* str) {
  while (*str)
    printc(*str++);
 }

// Dump byte as hexadecimal format

void dump_byte(int data) {
  char hex[] = "0123456789ABCDEF";

  printc(hex[ (data & 0xF0) >> 4 ]);    // Output higher nibble
  printc(hex[ data & 0x0F ]);           // Output lower nibble
 }

// Dump word as hexadecimal format

void dump_word(int data) {

  dump_byte((data & 0xFF00) >> 8);	// Output higher byte
  dump_byte(data & 0xFF);		// Output lower byte
 }
