//
// k b c . h
//
// Header file for the Keyboard controller module
//
// Sep. 10, 2002 by W.Nishida (http://www.skyfree.org)
//

// 8042 keyboard controler (KBC) definition

#define KBC_CTRL	0x64	// 8042 KBC control port (command/status)
#define KBC_DATA	0x60	// 8042 KBC data buffer
#define IOWAIT		0x80	// 1 miscrosec wait / access

#define KBC_OBF		0x01	// Output buffer is full (please read)
#define KBC_IBF		0x02	// Input buffer is full (don't write)
#define KBC_BUSY	(KBC_OBF | KBC_IBF)

// 8042 command bytes

#define KBC_GET_CTRL	0x20	// Read current 8042 control mode
#define KBC_SET_CTRL	0x60	// Setup 8042 control mode

// 8042 control mode

#define KBC_DO_XLAT	0x40	// Translate keyboard scan codes
#define KBC_DIS_MOUSE	0x20	// Disable mouse
#define KBC_DIS_KEY	0x10	// Disable keyboard
#define KBC_SYS_FLAG	0x04	// Setup system flag in status register
#define KBC_INT_MOUSE	0x02	// Mouse OBF causes IRQ12
#define KBC_INT_KEY	0x01	// Keyboard OBF causes IRQ1

// Device command bytes

#define KBC_WRITE_LED	0xED	// Write LED
#define KBC_SET_REPEAT	0xF3	// Setup keyboard repeat rate
#define KBC_ACK		0xFA	// ACK answer code

// 8259 programmable interrupt controller (PIC) definition

#define PIC_MIMR	0x21	// Master PIC IMR
#define PIC_IMR_KEY     2       // Master IMR keyboard IRQ bit

// Function prototypes

int  inb(int port);
void outb(int data, int port);
int  kbc_status(void);
void kbc_command(int cmd);
void kbc_write(int data);
int  kbc_read(void);
void disable_keyint(void);
void enable_keyint(void);
