//
// r a t e m i n . c
//
// Setup minimum key repeat rate
//
// Sep. 14, 2002 by W.Nishida (http://www.skyfree.org)
//

#include "kbc.h"
#include "dos-console.h"

asm(".code16gcc");

int main(void) {
  int ret;

  // Ignore keyboard interrupts

  disable_keyint();			// Disable keyboard interruption

  // Select minimum repeat rate & maximum delay

  kbc_write(KBC_SET_REPEAT);		// Send set keyboard repeat rate cmd
  ret = kbc_read();			// Read response code from kbd
  if (ret != KBC_ACK) {			// Acknowledged?
    prints("Can't send the command!\r\n");
    goto exit;
   }
  kbc_write(0x7F);			// Min repeat rate and max delay
  ret = kbc_read();			// Read response code from kbd
  if (ret != KBC_ACK) {			// Acknowledged?
    prints("Communication error!\r\n");	// No, then abort.
    goto exit;
   }

  // Reactivate keyboard interruption
 exit:
  enable_keyint();
  return 0;
 }
