//
// r a w s c a n . c
//
// Read "raw" scan codes
//
// Sep. 30, 2002 by W.Nishida (http://www.skyfree.org)
//

#include "kbc.h"
#include "dos-console.h"

asm(".code16gcc");

int main(void) {
  int ret;

  prints("Hit any key, please.\r\n");

  // Inhibit scan code translation

  kbc_command(KBC_GET_CTRL);		// Read current 8042 control mode
  ret = kbc_read();
  kbc_command(KBC_SET_CTRL);		// Update 8042 control mode
  ret &= ~KBC_DO_XLAT;			// Disable scan code translation
  ret &= ~KBC_INT_KEY;			// Disable keyboard interrupt
  kbc_write(ret);			// Send new control mode value

  // Read scancodes repeatedly

  while (1) {
    ret = kbc_read();			// Grub the data
    if (ret == 0x76)			// Is it ESC key?
      break;				// Then, exit loop
    dump_byte(ret);			// Display the scancode
    printc(' ');
   }

  // Recover scan code translation

  kbc_command(KBC_GET_CTRL);		// Read current 8042 control mode
  ret = kbc_read();
  kbc_command(KBC_SET_CTRL);		// Update 8042 control mode
  ret |= KBC_DO_XLAT;			// Enable scan code translation
  ret |= KBC_INT_KEY;			// Enable keyboard interrupt
  kbc_write(ret);			// Send new control mode value

  return 0;
 }
